version: "3"
services:
  backend:
    build: ./server/.
    ports:
      - "5500:5500"
    env_file:
      - variables.env
    environment:
      - MONGO_INITDB_ROOT_USERNAME=${MONGO_INITDB_ROOT_USERNAME}
      - MONGO_INITDB_ROOT_PASSWORD=${MONGO_INITDB_ROOT_PASSWORD}
      - MONGO_URL=mongodb://${MONGO_INITDB_ROOT_USERNAME}:${MONGO_INITDB_ROOT_PASSWORD}@database:27017/todolist


    # secrets:
    #   - mongo_root_user
    #   - mongo_root_password
    # environment:
    #   - MONGO_URL=mongodb://${MONGO_ROOT_USER}:${MONGO_ROOT_PASSWORD}@database:27017/todolist
    networks:
      todoapp_network:
        ipv4_address: 10.0.0.2

  frontend:
    build: ./client/.
    ports:
      - "3000:3000"
    depends_on:
      - backend
    networks:
      todoapp_network:
        ipv4_address: 10.0.0.3

  database:
    build: ./database/.
    ports:
      - "27017:27017"
    volumes:
      - mongodb-storage:/data/db 
    restart: unless-stopped
    env_file:
      - variables.env
    networks:
      todoapp_network:
        ipv4_address: 10.0.0.4

  mongo_express:
    image: mongo-express
    ports:
      - "8081:8081"
    env_file:
      - variables.env
    environment:
      - ME_CONFIG_MONGODB_PORT=${ME_CONFIG_MONGODB_PORT}
      - ME_CONFIG_MONGODB_ADMINUSERNAME=${ME_CONFIG_MONGODB_ADMINUSERNAME}
      - ME_CONFIG_MONGODB_ADMINPASSWORD=${ME_CONFIG_MONGODB_ADMINPASSWORD}
      - ME_CONFIG_MONGODB_ENABLE_ADMIN=true
      - ME_CONFIG_MONGODB_URL=mongodb://todoadmin:access@database:27017/todolist
    networks:
      todoapp_network:
        ipv4_address: 10.0.0.5
    depends_on:
      - database


    
    # secrets:
    #   - mongo_root_user
    #   - mongo_root_password
    

# # Defining Secrets internally 
# secrets:
#   mongo_root_user:
#     file: ./secrets/mongo_root_user.txt
#   mongo_root_password:
#     file: ./secrets/mongo_root_password.txt

# Defining network settings 
networks:
  todoapp_network:
    ipam:
      driver: default
      config:
        - subnet: 10.0.0.0/24

volumes:
  mongodb-storage:
    external: true
